/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jp.glassfish.sparrow.servlet3_0;

import java.io.IOException;
import java.util.ArrayList;
import java.util.concurrent.ScheduledThreadPoolExecutor;
import java.util.concurrent.ThreadPoolExecutor;
import javax.naming.Context;
import javax.servlet.AsyncContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.annotation.WebServlet;

/**
 *
 * @author Stakeuchi
 */
@WebServlet(urlPatterns = {"/AsyncWebApplication"}, asyncSupported = true)
public class ChatService extends HttpServlet {

    /** Serial Ver */
    private static final long serialVersionUID = 2825256419920406849L;

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        AsyncContext aCtx;
        try {
            aCtx = request.startAsync(request, response);
            if(request.getServletContext().getAttribute("message") == null) {
                ArrayList<Object> messageList = new ArrayList<Object>();
                request.getServletContext().setAttribute("message", messageList);
            }
            ScheduledThreadPoolExecutor executor = new ScheduledThreadPoolExecutor(10);
            executor.execute(new AsyncChatMessage(aCtx));
        } catch(Exception ex) {
            StackTraceElement[] stackTrace = ex.getStackTrace();
            @SuppressWarnings("unchecked")
            ArrayList<Object> messageList = (ArrayList)request.getServletContext().getAttribute("message");
            messageList.add(ex.getLocalizedMessage());
            final StringBuilder stackTraceBuffer = new StringBuilder();
            for(int i=0; i<stackTrace.length; i++) {
                stackTraceBuffer.append(stackTrace[i].getLineNumber()).append(" - ").append(stackTrace[i].getClassName());
                messageList.add(stackTraceBuffer.toString());
                request.getRequestDispatcher("/AsyncWebApplication/chat.jsp").forward(request, response);
            }
        } finally {
            
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet のメソッドです。コードを編集するには、左側の + 符号をクリックしてください。">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
